/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.77
        Device            :  PIC16F1705
        Driver Version    :  2.00

    LCD  ACM1602N1-FLW-FBW

    Temp/Humi sensor  SHT31

*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"
#include <stdio.h>
#include "lcd_lib2.h"
#include "i2c_lib2.h"
#include "i2c-lib.h"

#define SHT31_ADDR 0x8A         // ZT[X[uAhX`:0b1000101(0x45)+0 = 0b10001010 = 0x8A 

// O[oϐ錾
unsigned long St,Srh;           // xx16bitf[^i[pϐ
unsigned long Temp,Humi;        // Temp:xϐ,Humi:xϐ
unsigned long data[6];          // SHT31WX^Mf[^i[pϐ
unsigned int i,cnt,n,x,y;
unsigned long Threshold = 27;      // x臒l(deg.C)

char Message[] = "                Be aware of heatstroke !                ";      // bZ[W(56)

// vg^CsO錾
void SHT31(void);              // xZT[֐
void Conv(void);               // xlϊ֐

// Wo͊֐p჌x֐`
void putch(unsigned char data) {
    lcd_data(data);             // t\Wo͊֐Ƃ
}

/*
                         Main application
 */
void main(void)
{
    // initialize the device
    SYSTEM_Initialize();

    // When using interrupts, you need to set the Global and Peripheral Interrupt Enable bits
    // Use the following macros to:

    // Enable the Global Interrupts
    //INTERRUPT_GlobalInterruptEnable();

    // Enable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    // LCD
    lcd_init();       

    // ϐ
    n = 56;         // 
    y = 41;         // [v
    
    while (1)
    {
        // Add your application code

        SHT31();        // xZT[֐Ăяo        
        
        // LCDo
        lcd_cmd(0x80);          // LCD1s
            printf("%3lu degC %3lu %%RH", Temp,Humi);     // xl\

        __delay_ms(100);           // h~          

        if (Temp > Threshold) {      // x臒lȏȂMessage\

            for (x=0; x<y; x++) {

                i = x;          // LCD擪\Zbg

                for (cnt=0xC0; cnt<=0xCF; cnt++) {      // LCD2s       
                    lcd_cmd(cnt);                       // J[\LCD\ʒu
                    printf("%c", Message[i]);                                

                    i++;                // ̕
                    if (i > n)          // 񖖔Ȃ烋[v𔲂
                        break;   
                }

                __delay_ms(200);        // XN[Ԋu(0.2 sec)
            
            }
        }       
    }
}

// xZT[֐
void SHT31(void) {
// FxANbNXgb`

    unsigned int i;

// R}hM    
    i2c_start();                    // I2CX^[gRfBVs        
    i2c_send_byte(SHT31_ADDR);      // X[uID + 0(ݗv)
    i2c_send_byte(0x24);            // R}h(MSB) = 0x24 : NbNXgb`
    i2c_send_byte(0x0B);            // R}h(LSB) = 0x0B : x   
    i2c_stop();                     // I2CXgbvRfBVs     

    __delay_ms(5);                  // ҂ (x:m~i 4.5 msec)

// xf[^ǂݏo    
    i2c_start();                    // I2CX^[gRfBVs        
    i2c_send_byte(SHT31_ADDR + 1);  // X[uID + 1(ǂݍݗv)
    for (i=0; i<6; i++)             // f[^荞
    {
        if (i == 5)
            data[5] = i2c_read_byte(0);     // ŏIWX^MNACK
        else
            data[i] = i2c_read_byte(1);     // ȊO͎MACKԂ   
    }

    i2c_stop();             // I2CXgbvRfBVs     

    Conv();                 // xlϊ֐Ăяo

}

void Conv(void) {
// xZFT = -45 + 175 * St / (2^16-1)    
// x16bit(MSB+LSB)2i10iɕϊ
    St = (data[0] << 8) | data[1];          // x16bit(MSB+LSB) 
    Temp = St * 175 / 65535 - 45;           // 2^16-1 = 65535
    
// xZFRH = 100 * Srh / (2^16-1)
// x16bit(MSB+LSB)2i10iɕϊ
    Srh = (data[3] << 8) | data[4];          // x16bit(MSB+LSB)
    Humi = Srh * 100 / 65535;                //         
    
// CRC͏Ȃ()    
}

/**
 End of File
*/